%global goipath github.com/go-macaron/session
%global commit  0a0a789bf1934e55fde19629869caa015a40c525
Version:        0

%gometa

Name:           %{goname}
Release:        0.1%{?dist}
Summary:        Provides the session management of Macaron
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

# disable uncommon databases like nodb and ledis - not packaged
Patch0:         drop-exotic-dbs.patch

# ensure tests use in-memory databases and on non-default ports
Patch1:         local-tests-dbs.patch

BuildRequires:  golang(gopkg.in/redis.v2)
BuildRequires:  golang(gopkg.in/macaron.v1)
BuildRequires:  golang(github.com/bradfitz/gomemcache/memcache)
BuildRequires:  golang(github.com/smartystreets/goconvey/convey)

# perform testing on in-memory databases
BuildRequires:  redis memcached nmap-ncat

%description
%{summary}.


%package devel
Summary:       %{summary}
BuildArch:     noarch

%description devel
%{summary}.

This package contains library source intended for building other packages which
use import path with %{goipath} prefix.


%prep
%forgeautosetup -p1


%install
%goinstall


%check
# stop any pre-existing redis and memcached servers running
printf "shutdown\r\nquit\r\n" | ncat localhost 8131 2>/dev/null || true
redis-cli -p 8130 shutdown 2>/dev/null || true
# start temporary redis and memcached instances for testing
memcached -A --port 8131 &
redis-server --port 8130 &
sleep 0.2   # give these test services some time to startup
# run the actual tests
%gochecks
# stop both the newly-created redis and memcached instances
printf "shutdown\r\nquit\r\n" | ncat localhost 8131
redis-cli -p 8130 shutdown


%files devel -f devel.file-list
%doc README.md
%license LICENSE


%changelog
* Thu Mar 28 2019 Nathan Scott <nathans@redhat.com> - 0-0.1.20190328git0a0a789
- First package for Fedora
